/*
 *  Compatibility for old ric_waiter.
 *
 *  Needed starting with qlab 3.1.1338.
 */

class ric_waiter
{
public:
    ric_waiter();

    void add_ric(string ric, string source_and_feed = '');
    void remove_ric(string ric, string source_and_feed = '');

    void wait(integer timeout = -1);

private:
    rt.trigger	trigger;
};

ric_waiter ric_waiter()
    option(warning: "ric_waiter is deprecated, use rt.trigger instead")
{
    return new ric_waiter;
}

ric_waiter.ric_waiter()
    : trigger(new rt.trigger)
{}

void ric_waiter.add_ric(string ric, string source_and_feed)
{
    string	source;
    string	feed;

    rt.__feed2src(source_and_feed, source, feed);

    trigger.add_ric(ric, source, feed);
}

void ric_waiter.remove_ric(string ric, string source_and_feed)
{
    string	source;
    string	feed;

    rt.__feed2src(source_and_feed, source, feed);

    trigger.remove_ric(ric, source, feed);
}

void ric_waiter.wait(integer timeout)
{
    trigger.wait(timeout);
}
