option(null: hard);	// Throw error if a null value is used in a non-nullable context

/*	
	instrument wrapper functions
	Developer: Algorithmica Research, Magnus Nyström			

	--------------------------------------------------------------------
	fx_fwd
	--------------------------------------------------------------------
*/


//----------------------------------------------------------------------
//  class fx_fwd
//----------------------------------------------------------------------
class fx_fwd: public instrument
option(category: "Instrument/FX")
//option(allow_undeclared_mfuncs)
{
public:
    //override string			instr_type_s();
	override instrument 	inst();

	void  		nominal(	out number ,out number ,error_info option(nullable) error = null<error_info>);
	date 		spot_date(error_info option(nullable) error = null<error_info>) ;
	integer 	pip_decimals(error_info option(nullable) error = null<error_info> );
	integer 	quote_dec(error_info option(nullable) error = null<error_info> ); 
	integer 	scale(error_info option(nullable) error = null<error_info> ); 
	logical 	reverse_ric(error_info option(nullable) error = null<error_info>); 
	logical 	is_post_spot(instrument,error_info option(nullable) error = null<error_info> ) ;
	string 		base_ccy(error_info option(nullable) error = null<error_info> ) ;
	string 		price_ccy(error_info option(nullable) error = null<error_info>) ;
	string 		spot_name(error_info option(nullable) error = null<error_info> ) ;
	string 		spot_code(error_info option(nullable) error = null<error_info> ) ;
	calendar 	base_ccy_calendar(error_info option(nullable) error = null<error_info> ) ;
	calendar 	price_ccy_calendar(error_info option(nullable) error = null<error_info> ) ;
	calendar 	usd_calendar(error_info option(nullable) error = null<error_info>) ;
	string 		base_ccy_calendar_name(error_info option(nullable) error = null<error_info> ) ;
	string 		price_ccy_calendar_name(error_info option(nullable) error = null<error_info>) ;
	string 		usd_calendar_name(error_info option(nullable) error = null<error_info> ) ;
	fx_spot_rule spot_rule(error_info option(nullable) error = null<error_info>);	
	number 		pips(number ,number ,error_info option(nullable) error = null<error_info>);
		
	number 		cross_quote(number option(nullable) ,fx_fwd,number option(nullable) ,logical,integer,integer ,logical,	
								out string	,out string	,error_info option(nullable) error = null<error_info> );	
	
	void 		cross_quote(number  ,number  ,fx_fwd,number ,number ,out number ,out number ,
							logical fx2_is_base = false,integer cross_scale = 1,integer cross_decimals = 15,
							logical	cross_fix_spread = false,number option(nullable) cross_bid_spread = null<number>,
							number option(nullable) cross_ask_spread = null<number>,logical cross_unit_quote = false,
							error_info option(nullable) error = null<error_info>); 

	void 		cross_quote(number option(nullable) ,fx_fwd	,number option(nullable) ,logical,INSTR_TMPL.fx_fwd_def_tmpl  ,
							out fx_fwd, error_info option(nullable) error = null<error_info> );

	void		cross_quote(	number   	bid_quote,
							number   	ask_quote,
							fx_fwd 		fx2,
							number   	fx2_bid_quote,
							number   	fx2_ask_quote,
							logical 	fx2_is_base,
							INSTR_TMPL.fx_fwd_def_tmpl fx_tmpl,
							out fx_fwd 			cross_bid,
							out fx_fwd 			cross_ask,														
							logical					cross_fix_spread,
							number option(nullable) cross_bid_spread,
							number option(nullable) cross_ask_spread,								
							error_info option(nullable) error = null<error_info>) ;

	number 		df_to_fwd(	disc_func,disc_func,..fx_spot ,fx_swap option(nullable) ,
								logical	unit_quote = false,logical 	no_rnd = false,	
								error_info option(nullable) error = null<error_info>) ;

	number 		df_to_fwd(	disc_func,disc_func,number ,number option(nullable) ,
								logical	unit_quote = false,logical 	no_rnd = false,	
								error_info option(nullable) error = null<error_info>) ;
	
	logical 	is_post_spot(..fx_spot ,error_info option(nullable) error = null<error_info>) ;

	number 		swap_points(number option(nullable) ,..fx_spot,fx_swap option(nullable),
									logical	unit_quote = false,logical no_rnd = false,
									error_info option(nullable) error = null<error_info>);

	number 		swap_points(number option(nullable) ,number,number option(nullable),
									logical	unit_quote = false,logical no_rnd = false,
									error_info option(nullable) error = null<error_info>);
	
	fx_spot 	create_fx_spot(string option(nullable) ,error_info option(nullable) error = null<error_info>);

	fx_spot 	create_fx_spot(number option(nullable) quote = null<number>, error_info option(nullable) error = null<error_info>);
	
	integer 	scale_inv(error_info option(nullable) error = null<error_info>);

	fx_fwd		set_quote(number option(nullable) ,date  option(nullable) ,logical option(nullable) ,error_info option(nullable) error = null<error_info> );
	fx_fwd		set_quote(number option(nullable) ,logical option(nullable) ,error_info option(nullable) error = null<error_info> );
	
	override void add_quote(number,logical option(nullable));

	instrument  synt_depo(instrument,day_count_method,number,day_count_method,logical ,instrument option(nullable),
								error_info option(nullable) error = null<error_info>) ;

	override number quote(error_info option(nullable) error = null<error_info>);
	override number quote(..quote_style option(nullable),error_info option(nullable) error = null<error_info>);			
	//FIX_ME: following 3 quote funcs return err but should be implemented
	//override number 			quote(date option(nullable) ,  string option(nullable) , out instr_error option(nullable));
	//override number	 		quote(integer,  string option(nullable) quote_side = null<string>, error_info option(nullable) error = null<error_info>);	
	//override vector(number) 	quote(vector(date) ,  string option(nullable) quote_side = null<string>, error_info option(nullable) error = null<error_info>);	


	number 		quote(	logical	,logical ,error_info option(nullable) error = null<error_info>);
	number 		quote_inv(	number option(nullable),logical,error_info option(nullable) error = null<error_info> );

	fx_fwd			set_date(date,logical,logical ,error_info option(nullable) error = null<error_info>);						

	fx_fwd(__instrument);	
	override fx_fwd clone();
	fx_fwd(fx_fwd);

protected:
	
	override fx_fwd		create(	__instrument option(nullable),out instr_error option(nullable),error_type type = E_INVALID_ARG);
						
	override fx_fwd		set_date(date,date option(nullable) s=null<date> ,logical r = true,logical rq = true ,error_info option(nullable) error = null<error_info>);	
	override fx_fwd		set_date(date,logical ,error_info option(nullable) error = null<error_info>);									/*legacy*/
	override fx_fwd		move_date(	date,date option(nullable) s=null<date> , error_info option(nullable) error = null<error_info>);	/*legacy*/

	override instrument  	fx_synt_depo(instrument,day_count_method,number,day_count_method,logical ,instrument option(nullable),
										error_info option(nullable) error = null<error_info> ) ;

	/*err funcs*/
	//override number 		quote(..quote_style.quote_style ,out instr_error option(nullable));	
	override number 		quote(disc_func,..quote_style option(nullable),error_info option(nullable) error = null<error_info>);
	void 					currencies(	out string , out string );
};

//------------------------------------------------
// create  [PROTECTED]
// create fx_swap from internal instrument
//------------------------------------------------
fx_fwd fx_fwd.create(	__instrument option(nullable) 		c,
						out instr_error option(nullable) 	error,
						error_type 							type )
{
	QL_FAIL_COND(null(c), "invalid/unknown (null) instrument",type );

	logical valid = c.is_valid(error);
	if( !valid && INSTR_CREATE_NULL_ERR)
		return null<fx_fwd>; 
	
	..instr_type it = c.instr_type(error);
	QL_FAIL_COND(null(it), "invalid instrument type (unknown)",type );
	QL_FAIL_COND(it != ..instr_type.FX_FORWARD, "invalid instrument type",type );//should not happen
	
	return new fx_fwd(c);
}

/*-----------------------------------------------------------------------
  create_fx_fwd
  ----------------------------------------------------------------------*/
fx_fwd create_fx_fwd(	__instrument option(nullable) c,
						out instr_error option(nullable) error,
						error_type type = E_INVALID_ARG)
option(com_name: 'INTERNAL_create_fx_fwd')
{
	QL_FAIL_COND(null(c), "invalid/unknown (null) instrument",type );

	logical valid = c.is_valid(error);
	if( !valid && INSTR_CREATE_NULL_ERR)
		return null<fx_fwd>; 
	
	..instr_type it = c.instr_type(error);
	QL_FAIL_COND(null(it), "invalid instrument type (unknown)",type );
	QL_FAIL_COND(it != ..instr_type.FX_FORWARD, "invalid instrument type",type );//should not happen
	
	return new fx_fwd(c);
}
fx_fwd create_fx_fwd(	__instrument option(nullable) 		c,
						error_info option(nullable) 		error,
						error_type 							type = E_INIT)
option(com_name: 'INTERNAL_create_fx_fwd_ei')
{
	instr_error ee 	= instr_error();
	fx_fwd b 	= create_fx_fwd(c,ee, E_INIT);
	if(ee.is_error())
		CORE_INT.add_error_info(error,ee.type(),ee.message(), "create_fx_fwd");
	return b;
}
//------------------------------------------------
// constructor [HIDDEN, cannot be protected]
//------------------------------------------------
fx_fwd.fx_fwd(__instrument i) option(hidden): instrument(i){}
//------------------------------------------------
// instr_type_s
//------------------------------------------------
//string fx_fwd.instr_type_s() 	{ return string(..instr_type.FX_FORWARD);}
//------------------------------------------------
// inst
//------------------------------------------------
instrument 	fx_fwd.inst()		{ return this;}
//------------------------------------------------
// copy constructor
//------------------------------------------------
fx_fwd.fx_fwd(fx_fwd c) : instrument(c) {}
//------------------------------------------------
// copy constructor <FUNCTION>
//------------------------------------------------
fx_fwd fx_fwd(fx_fwd b)		{ return new fx_fwd(b);}
//------------------------------------------------
// clone
//------------------------------------------------
fx_fwd fx_fwd.clone()		{ return new fx_fwd(this);}

//-----------------------------------------------
// dynamic cast <FUNCTION>
//-----------------------------------------------
fx_fwd fx_fwd(instrument i, error_info option(nullable) error = null<error_info>) 	
option (category: 'Instrument/FX')
option(com_name: 'fx_fwd_dyncast') 
{ 
	try {
		fx_fwd d = dynamic_cast<fx_fwd>(i); 
		if(null(d))
			CORE_INT.add_error_info(error,ERR_T_INIT,"invalid cast (instrument is not a fx_fwd)","fx_fwd" );

		return d;
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "fx_fwd");
		return null<fx_fwd>;
	}
}

/*-----------------------------------------------------------------------
  set_date  (a version without settledate as argument)
	if trade date is the same --> the settle date will be preserved (if not input)	
	NOTE: 	if coupon is not null in instr_def it is kept unchanged --> deposit will be non-par 
			when a deposit is defined in db the coupon is always null
  ----------------------------------------------------------------------*/
fx_fwd fx_fwd.set_date(	date  				trade_date, 					
						logical 			re_init_static, 
						logical 			re_init_quote, 
						error_info option(nullable) error)
{	
	instrument cc = instrument._set_date(trade_date,null<date>,re_init_static,re_init_quote,error);
	return null(cc) ? null<fx_fwd>: dynamic_cast<fx_fwd>(cc);
	
}

/*-----------------------------------------------------------------------
  bill: set_date <protected>
	if trade date is the same --> the settle date will be preserved (if not input)	
	NOTE: 	if coupon is not null in instr_def it is kept unchanged --> deposit will be non-par 
			when a deposit is defined in db the coupon is always null
  ----------------------------------------------------------------------*/
fx_fwd fx_fwd.set_date(	date  				trade_date, 
							date  option(nullable)	settle_date,
							logical 			re_init_static, 
							logical 			re_init_quote, 
							error_info option(nullable) error)
{	
	instrument cc = instrument._set_date(trade_date,null<date>,re_init_static,re_init_quote,error);
	return null(cc) ? null<fx_fwd>: dynamic_cast<fx_fwd>(cc);
	
}
/*-----------------------------------------------------------------------
  set_date <protected/legacy>
	quote is NOT kept even if trade_date is unchanged
  ----------------------------------------------------------------------*/
fx_fwd fx_fwd.set_date(	date  				trade_date, 
							logical 			re_init_static, 
							error_info option(nullable) error) 

{	
	instrument cc = instrument._set_date(trade_date,re_init_static,error);
	return null(cc) ? null<fx_fwd>: dynamic_cast<fx_fwd>(cc);	
}
/*-----------------------------------------------------------------------
   move_date  <protected/legacy>
	changes the trade date of the instrument without retrieving the 
 	corresponding quote from the database or the real-time feed.
	if trade date is the same --> the settle date will be preserved	
  ----------------------------------------------------------------------*/
fx_fwd fx_fwd.move_date(	date  				trade_date, 
							date option(nullable) settle_date,
							error_info option(nullable) error) 
{	
	instrument cc = instrument._move_date(trade_date,null<date>,error);
	return null(cc) ? null<fx_fwd>: dynamic_cast<fx_fwd>(cc);
}

/*-----------------------------------------------------------------------
  fx_fwd: nominal
  ----------------------------------------------------------------------*/
void  fx_fwd.nominal(	out number base_ccy_nominal,
						out number price_ccy_nominal,	
						error_info option(nullable) error)
{	
	try{	
		instr_error_type t;
   		string 			s;	
		i().__fx_nominal(base_ccy_nominal,price_ccy_nominal,t, s);		
		logical e = CORE_INT.add_error_info(error,t,s, "fx_fwd.nominal");
		if(e)
			base_ccy_nominal = price_ccy_nominal = null<number>;
		return;
		
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "fx_fwd.nominal");
		base_ccy_nominal = price_ccy_nominal = null<number>;
		return ;
	}
}

date 	fx_fwd.spot_date(error_info option(nullable) error) 					{ return fx_spot_date(error) ;}
integer fx_fwd.pip_decimals(error_info option(nullable) error)					{ return fx_pip_decimals(error);}
integer fx_fwd.quote_dec(error_info option(nullable) error) 					{ return fx_quote_dec(error);}
integer fx_fwd.scale(error_info option(nullable) error)							{ return fx_scale(error);}
logical fx_fwd.reverse_ric(error_info option(nullable) error)					{ return fx_reverse_ric(error);}
logical fx_fwd.is_post_spot(instrument fxs,error_info option(nullable) error) 	{ return fx_is_post_spot(fxs,error);} 
string  fx_fwd.base_ccy(error_info option(nullable) error)						{ return fx_base_ccy(error);}
string  fx_fwd.price_ccy(error_info option(nullable) error)						{ return fx_price_ccy(error);}
string  fx_fwd.spot_name(error_info option(nullable) error)						{ return fx_spot_name(error);}
string  fx_fwd.spot_code(error_info option(nullable) error)						{ return fx_spot_code(error);}
string  fx_fwd.price_ccy_calendar_name(error_info option(nullable) error)		{ return fx_price_ccy_calendar_name(error);}
string  fx_fwd.base_ccy_calendar_name(error_info option(nullable) error)		{ return fx_base_ccy_calendar_name(error);}
string  fx_fwd.usd_calendar_name(error_info option(nullable) error)				{ return fx_usd_calendar_name(error);}
calendar fx_fwd.price_ccy_calendar(error_info option(nullable) error)			{ return fx_price_ccy_calendar(error);}
calendar fx_fwd.base_ccy_calendar(error_info option(nullable) error)			{ return fx_base_ccy_calendar(error);}
calendar fx_fwd.usd_calendar(error_info option(nullable) error)					{ return fx_usd_calendar(error);}
fx_spot_rule fx_fwd.spot_rule(error_info option(nullable) error)				{ return fx_rule(error);}

/*-----------------------------------------------------------------------
  fx_fwd: set_quote
  ----------------------------------------------------------------------*/
fx_fwd fx_fwd.set_quote(	number 	option(nullable) quote,
							date  	option(nullable) trade_date, 
							logical option(nullable) quote_is_unit,								
							error_info option(nullable) error) 
{	
	try{
		instr_error e 	= instr_error();
		__instrument ci = i();
		
		CORE_INT.instr_fail_check(null(ci), "invalid fx_fwd (null)", this, e);
		logical v = ci.is_valid(e);
		CORE_INT.instr_fail_check(!v, "invalid fx_fwd", this, e);
		
		__instrument  c = ci.__fx_set_quote(quote, trade_date,quote_is_unit);
		
		fx_fwd cc 		= create(c, e, E_INIT);
		CORE_INT.instr_fail_check(null(cc), "invalid fx_fwd", this, e);
		
		if(!cc.is_valid(error))
			return null<fx_fwd>;
		
		return cc ;					
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "fx_fwd.set_quote");
		return null<fx_fwd>;
	}
}

fx_fwd fx_fwd.set_quote(	number 		option(nullable) quote,							
							logical 	option(nullable) quote_is_unit,
							error_info option(nullable) error )  
{
	return this.set_quote(	quote,null<date>  ,quote_is_unit, error ) ;
}
/*-----------------------------------------------------------------------
  fx_fwd: synt_depo
  ----------------------------------------------------------------------*/
instrument  fx_fwd.synt_depo(instrument 				fx_spot,
							day_count_method 		dc_synt,
							number 					rate,
							day_count_method 		dc,
							logical 				synt_is_base,	
							instrument option(nullable)	fx_swap_tn,
							error_info option(nullable) error) 
{	
	try{	
		instr_error_type t;
   		string 			s;
		__instrument tn = null(fx_swap_tn) ? null<__instrument> : fx_swap_tn.i();
		__instrument c = i().__fx_synt_depo(fx_spot.i(),dc_synt,rate,dc,synt_is_base,tn,t, s);
		logical e 		= CORE_INT.add_error_info(error,t,s, "fx_fwd.synt_depo");				
		return e ? null<deposit> : new deposit(c);	
				
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "fx_fwd.synt_depo");
		return null<instrument >;
	}
}

/*-----------------------------------------------------------------------
  fx_fwd: fx_synt_depo
  ----------------------------------------------------------------------*/
instrument  fx_fwd.fx_synt_depo(instrument 				fx_spot,
								day_count_method 		dc_synt,
								number 					rate,
								day_count_method 		dc,
								logical 				synt_is_base,	
								instrument option(nullable)	fx_swap_tn,
								error_info option(nullable) error) option(hidden)
{
	return this.synt_depo(fx_spot,dc_synt,rate,dc,synt_is_base,fx_swap_tn,error) ;
}
/*-----------------------------------------------------------------------
  add_quote
  ----------------------------------------------------------------------*/
void fx_fwd.add_quote(	number  quote,
						logical option(nullable) quote_is_unit)
{		
	instrument.fx_add_quote(quote,quote_is_unit);						
}

/*-----------------------------------------------------------------------
  pips
  ----------------------------------------------------------------------*/
number 	fx_fwd.pips(number fx_quote1,
					number fx_quote2,	
					error_info option(nullable) error)	
{ 
	return (fx_quote2-fx_quote1)*pow(10.0, fx_pip_decimals(error));
}

/*-----------------------------------------------------------------------
  fx_df_to_fwd
  ----------------------------------------------------------------------*/
number  fx_fwd.df_to_fwd(	disc_func 					disc_func_base, 
    						disc_func 					disc_func_price,									
							..fx_spot 					fx_spot,
							fx_swap option(nullable) 	fx_swap_tn,
							logical						unit_quote,
							logical 					no_rnd,	
							error_info option(nullable) error) 
{	
	try{	
		instr_error_type t;
   		string 			s;	
		number c = i().__fx_df_to_fwd(disc_func_base,disc_func_price,fx_spot.i(),
									null(fx_swap_tn) ? null<__instrument> : fx_swap_tn.i() ,
									unit_quote,no_rnd,t, s);
		logical e = CORE_INT.add_error_info(error,t,s, "fx_fwd.df_to_fwd");	
		return e ? null<number>: c;							
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "fx_fwd.df_to_fwd");
		return null<number>;
	}
}
/*-----------------------------------------------------------------------
  fx_df_to_fwd
  ----------------------------------------------------------------------*/
number  fx_fwd.df_to_fwd(	disc_func 					disc_func_base, 
    						disc_func 					disc_func_price,									
							number 					fx_spot_quote,
							number option(nullable) 	fx_swap_tn_quote,
							logical						unit_quote,
							logical 					no_rnd,	
							error_info option(nullable) error) 
{	
	try{	
		instr_error_type t;
   		string 			s;	
		number c = i().__fx_df_to_fwd(disc_func_base,disc_func_price,fx_spot_quote,
									fx_swap_tn_quote ,
									unit_quote,no_rnd,t, s);
		logical e = CORE_INT.add_error_info(error,t,s, "fx_fwd.df_to_fwd");	
		return e ? null<number>: c;							
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "fx_fwd.df_to_fwd");
		return null<number>;
	}
}
/*-----------------------------------------------------------------------
  is_post_spot
  ----------------------------------------------------------------------*/
logical  fx_fwd.is_post_spot(	..fx_spot fx_spot,
								error_info option(nullable) error) 
{	
	return instrument.fx_is_post_spot(fx_spot, error);
}

/*-----------------------------------------------------------------------
  fx_fwd: swap_points
  ----------------------------------------------------------------------*/
number  fx_fwd.swap_points(	number option(nullable) quote,
							..fx_spot				fx_spot,
							fx_swap option(nullable) fx_swap_tn,
							logical					unit_quote,
							logical 				no_rnd,	
							error_info option(nullable) error)
{	
	try{	
		instr_error_type t;
   		string 			s;	
		number c = i().__fx_fwd_to_swap(quote,fx_spot.i(),
										null(fx_swap_tn) ? null<__instrument> : fx_swap_tn.i() ,
										unit_quote,no_rnd,t, s);
		logical e = CORE_INT.add_error_info(error,t,s, "fx_fwd.swap_points");	
		return e ? null<number>: c;							
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "fx_fwd.swap_points");
		return null<number>;
	}
}
/*-----------------------------------------------------------------------
  fx_fwd: swap_points
  ----------------------------------------------------------------------*/
number  fx_fwd.swap_points(	number option(nullable) quote,
							number				fx_spot_quote,
							number option(nullable) fx_swap_tn_quote,
							logical					unit_quote,
							logical 				no_rnd,	
							error_info option(nullable) error)
{	
	try{	
		instr_error_type t;
   		string 			s;	
		number c = i().__fx_fwd_to_swap(quote,fx_spot_quote,fx_swap_tn_quote ,
										unit_quote,no_rnd,t, s);
		logical e = CORE_INT.add_error_info(error,t,s, "fx_fwd.swap_points");	
		return e ? null<number>: c;							
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "fx_fwd.swap_points");
		return null<number>;
	}
}
/*-----------------------------------------------------------------------
  currencies  internal
  ----------------------------------------------------------------------*/
void fx_fwd.currencies(	out string b_ccy,
						out string p_ccy)
{
	
	error_info ee = error_info(true,true);
	
	p_ccy = price_ccy(ee);		
	CORE_INT.instr_fail_check(null(p_ccy), "invalid price currency", this, ee);

	b_ccy = base_ccy(ee);
	CORE_INT.instr_fail_check(null(b_ccy), "invalid base currency", this, ee);
		
}
/*-----------------------------------------------------------------------
  create_fx_spot
  ----------------------------------------------------------------------*/
fx_spot fx_fwd.create_fx_spot(	string option(nullable) quote_side,
								error_info option(nullable) error)
{	
	try{
		string bc,pc;
		currencies(	bc,pc);		
		instrument_name name 	= CORE_INT_FX.fx_inst_name(bc, pc);			
		__instrument c 			= __instrument(name,this.trade_date(),quote_side, null<date> );
		instr_error e 			= new instr_error();	
		fx_spot fxs 			= ..create_fx_spot( c, e);
		CORE_INT.instr_fail_check(null(fxs), "invalid fx_spot", this, e);
		return fxs;				
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "fx_fwd.create_fx_spot");
		return null<..fx_spot>;
	}
}

/*-----------------------------------------------------------------------
  create_fx_spot
  ----------------------------------------------------------------------*/
fx_spot fx_fwd.create_fx_spot(	number option(nullable) quote,
								error_info option(nullable) error)
{	
	try{	
		string bc,pc;
		currencies(	bc,pc);		
		instrument_name name = CORE_INT_FX.fx_inst_name(bc, pc);
		__instrument c;
		
		if(null(quote))
			c = __instrument(name,this.trade_date(), null<string>, null<date> );					
		else 
			c = __instrument(name,this.trade_date(), quote, null<date> );

		instr_error e 	= new instr_error();	
		fx_spot fxs 	= ..create_fx_spot( c, e);
		CORE_INT.instr_fail_check(null(fxs), "invalid fx_spot", this, e);
		return fxs;
		
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "fx_fwd.create_fx_spot");
		return null<..fx_spot>;
	}
}

/*-----------------------------------------------------------------------
  scale_inv 
	number of units of base currency in inverted pair 
  ----------------------------------------------------------------------*/
integer  fx_fwd.scale_inv(error_info option(nullable) error)
{	
	try{
		string bc,pc;
		currencies(	bc,pc);
		
		instrument_name name = CORE_INT_FX.fx_inst_name(pc, bc);		
		__instrument c = __instrument(name,this.trade_date(),1, null<date> );

		instr_error e = new instr_error();
		fx_spot fxs_inv = ..create_fx_spot( c, e);
		CORE_INT.instr_fail_check(null(fxs_inv), "invalid fx_spot inverted", this, e);
		return fxs_inv.scale(error);
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "fx_fwd.scale_inv");
		return err_int();
	}
}

/*-----------------------------------------------------------------------
  quote_inv
	--> price_currency is always the underlying
  ----------------------------------------------------------------------*/
number  fx_fwd.quote_inv(	number option(nullable)		inv_scale,
							logical 					no_rnd,		
							error_info option(nullable) error)
{
	try {
		if(!null(inv_scale) && inv_scale > 0)		
			return fx_quote_inv(inv_scale,no_rnd,error);
		else {
			error_info ee = error_info(true,true);
			integer s = scale_inv(ee);
			if(s == err_int()) s = 1;
			return fx_quote_inv(s,no_rnd,error);
		}
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "fx_fwd.quote_inv");
		return null<number>;
	}
}

/*-----------------------------------------------------------------------
  fx_fwd: quote
  ----------------------------------------------------------------------*/
number  fx_fwd.quote(	logical		unit_quote,
						logical 	no_rnd,	
						error_info option(nullable) error)
{	
	return instrument.fx_quote(unit_quote,no_rnd,error);
}

/*-----------------------------------------------------------------------
  fx_fwd: quote   
  ----------------------------------------------------------------------*/
number  fx_fwd.quote(error_info option(nullable) error)
{	
	return this.quote(false,false, error);
}

/*-----------------------------------------------------------------------
  fx_fwd: quote   
  ----------------------------------------------------------------------*/
number  fx_fwd.quote(..quote_style option(nullable) qs, error_info option(nullable) error)
{	
	try {
		QL_FAIL_COND(!null(qs) && qs != ..quote_style.FX_RATE, "invalid quote style (only FX_RATE is applicable)", this, true) ;			
		return this.quote(false,false, error);
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "fx_fwd.quote");
		return null<number>;
	}
}

/*-----------------------------------------------------------------------
  fx_fwd: quote_inv
  ----------------------------------------------------------------------*/
/*number  fx_fwd.quote_inv(	number option(nullable)		scale,	
							error_info option(nullable) error)
{	
	return fx_quote_inv(scale,error);
}


*/


/*-----------------------------------------------------------------------
  set_quote
  ----------------------------------------------------------------------*/
/*fx_fwd fx_fwd.set_quote(number 	option(nullable) 		quote,
							logical 						quote_is_unit,
							error_info option(nullable) error)
{		
	instrument c 	= instrument.fx_set_quote(quote, null<date>, quote_is_unit, error);
	return dynamic_cast<fx_fwd>(c); 

}
*/

/*-----------------------------------------------------------------------
  fx_fwd: cross_quote
  ----------------------------------------------------------------------*/
void  fx_fwd.cross_quote(	number option(nullable) quote,
							fx_fwd					fx2,
							number option(nullable) fx2_quote,
							logical 				fx2_is_base,
							INSTR_TMPL.fx_fwd_def_tmpl  fx_tmpl,
							out fx_fwd				cross,							
							error_info option(nullable) error)
{	
	try{	
		integer	cross_scale 		= 1;
		integer cross_decimals 		= 15;
		logical cross_unit_quote 	= true;

		instr_error ee = new instr_error();
		date mat 	= this.maturity();
		date mat2 	= fx2.maturity();
		CORE_INT.instr_fail_check(mat != mat2, "settlement date mismatch", this, ee);
		
		instr_error_type t;
   		string cross_base, cross_price,s;	
		number q_unit = i().__fx_cross_quote(quote,fx2.i(), fx2_quote,fx2_is_base,cross_scale,cross_decimals,
									cross_unit_quote,cross_base,cross_price,t, s);
		logical e = CORE_INT.add_error_info(error,t,s, "fx_fwd.cross_quote");			
		if(e) {
			cross = null<fx_fwd>;
			return;
		}		
		
		CORE_INT.instr_fail_check(fx_tmpl.base_ccy() != cross_base, "invalid template (base currency mismatch)", this, ee);
		CORE_INT.instr_fail_check(fx_tmpl.price_ccy() != cross_price, "invalid template (price currency mismatch)", this, ee);
				
		error_info er 		= new error_info(true,true);
		..instr_def def 	= instr_def_fx_fwd(fx_tmpl,er);
		if(null(def)|| !def.is_valid()) {			
			CORE_INT.instr_fail_check(true, strcat(["error creating fx-cross instr_def (",fx_tmpl.name()," )"]), this, ee);
		}

		date m = fx_adj_date(mat,fx_tmpl.base_ccy_calendar(),fx_tmpl.price_ccy_calendar(),
							 fx_tmpl.fx_rule(), fx_tmpl.usd_calendar());

		/*Note: if m != mat --> adjustment to the input outr-rates?*/
		__instrument ci 	= __instrument_fxfwd_nodb(def,"outr",this.trade_date(),m,null<number>, null<number> );
		
		if(null(ci)|| !ci.is_valid(ee)) {			
			CORE_INT.instr_fail_check(true, strcat(["error creating fx-cross (",fx_tmpl.name()," )"]), this, ee);
		}
	
				
		cross 			= create_fx_fwd( ci, ee);
		CORE_INT.instr_fail_check(null(cross) || !cross.is_valid(), "invalid cross", this, ee);
		cross.set_quote(q_unit,this.trade_date(),cross_unit_quote, error) ;
				
		return ;						
	}
	catch {
		cross = null<fx_fwd>;
		CORE_INT.catch_error_info(error,err.type(),err.message(), "fx_fwd.cross_quote");
		return ;
	}
}

/*-----------------------------------------------------------------------
  fx_fwd: cross_quote
  ----------------------------------------------------------------------*/
number  fx_fwd.cross_quote(number option(nullable) quote,
							fx_fwd					fx2,
							number option(nullable) fx2_quote,
							logical 				fx2_is_base,
							integer					cross_scale,
							integer 				cross_decimals,	
							logical 				cross_unit_quote,
							out string				cross_base,
							out string				cross_price,	
							error_info option(nullable) error)
{	
	try{
		instr_error ee 	= new instr_error();
		date mat 	= this.maturity();
		date mat2 	= fx2.maturity();
		CORE_INT.instr_fail_check(mat != mat2, "settlement date mismatch", this, ee);
		
		instr_error_type t;
   		string 			s;	
		number c = i().__fx_cross_quote(quote,fx2.i(), fx2_quote,fx2_is_base,cross_scale,cross_decimals,cross_unit_quote,cross_base,cross_price,t, s);
		logical e = CORE_INT.add_error_info(error,t,s, "fx_fwd.cross_quote");
		if(e) {
			cross_base = cross_price = null<string>;		
			return null<number>;
		}		
		return c;							
	}
	catch {
		cross_base = cross_price = null<string>;
		CORE_INT.catch_error_info(error,err.type(),err.message(), "fx_fwd.cross_quote");
		return null<number>;
	}
}
/*-----------------------------------------------------------------------
  cross_quote
  fx_cross defined from template
  ----------------------------------------------------------------------*/
void  fx_fwd.cross_quote(	number   	bid_quote,
							number   	ask_quote,
							fx_fwd 		fx2,
							number   	fx2_bid_quote,
							number   	fx2_ask_quote,
							logical 	fx2_is_base,
							INSTR_TMPL.fx_fwd_def_tmpl  fx_tmpl,
							out fx_fwd 			cross_bid,
							out fx_fwd 			cross_ask,														
							logical					cross_fix_spread,
							number option(nullable) cross_bid_spread,
							number option(nullable) cross_ask_spread,								
							error_info option(nullable) error) 

{	
	try{
		integer	cross_scale 		= 1;
		integer cross_decimals 		= 15;
		logical cross_unit_quote 	= true;

		instr_error ee 	= new instr_error();
		date mat 	= this.maturity();
		date mat2 	= fx2.maturity();
		CORE_INT.instr_fail_check(mat != mat2, "settlement date mismatch", this, ee);
		
		number cross_bidq,cross_askq;
		instr_error_type t;
   		string 	cross_base, cross_price,s;
		i().__fx_cross_quote(bid_quote,ask_quote,fx2.i(), fx2_bid_quote,fx2_ask_quote,cross_bidq,cross_askq,
							fx2_is_base,cross_scale,cross_decimals,cross_fix_spread,cross_bid_spread,
							cross_ask_spread, cross_unit_quote,cross_base, cross_price,t, s);
		logical e = CORE_INT.add_error_info(error,t,s, "fx_fwd.cross_quote");	
		if(e) {			
			cross_bid = cross_ask = null<fx_fwd>;
			return;
		}
		
		CORE_INT.instr_fail_check(fx_tmpl.base_ccy() != cross_base, "invalid template (base currency mismatch)", this, ee);
		CORE_INT.instr_fail_check(fx_tmpl.price_ccy() != cross_price, "invalid template (price currency mismatch)", this, ee);
				
		error_info er 	= new error_info(true,true);
		..instr_def def = instr_def_fx_fwd(fx_tmpl,er);
		if(null(def) || !def.is_valid()) {			
			CORE_INT.instr_fail_check(true, strcat(["error creating fx-cross instr_def (",fx_tmpl.name()," )"]), this, ee);
		}

		date m = fx_adj_date(mat,fx_tmpl.base_ccy_calendar(),fx_tmpl.price_ccy_calendar(),fx_tmpl.fx_rule(), fx_tmpl.usd_calendar());
		/*Note: if m != mat --> adjustment to the input outr-rates?*/
		
		__instrument ci = __instrument_fxfwd_nodb(def,"outr",this.trade_date(),m,null<number>, null<number> );
		
		if(null(ci) || !ci.is_valid(ee)) {			
			CORE_INT.instr_fail_check(true, strcat(["error creating fx-cross (",fx_tmpl.name()," )"]), this, ee);
		}
		
		cross_bid 		= create_fx_fwd( ci, ee);
		CORE_INT.instr_fail_check(null(cross_bid) || !cross_bid.is_valid(), "invalid bid cross", this, ee);
		cross_ask 		= create_fx_fwd( ci, ee);
		CORE_INT.instr_fail_check(null(cross_ask) || !cross_ask.is_valid(), "invalid ask cross", this, ee);							
		cross_bid 		= cross_bid.set_quote(cross_bidq,this.trade_date(),cross_unit_quote, error) ;
		cross_ask 		= cross_ask.set_quote(cross_askq,this.trade_date(),cross_unit_quote, error) ;
		
		return ;						
	}
	catch {
		cross_bid = cross_ask = null<fx_fwd>;
		CORE_INT.catch_error_info(error,err.type(),err.message(), "fx_fwd.cross_quote");
		return ;
	}
}
/*-----------------------------------------------------------------------
  fx_fwd: cross_quote
  ----------------------------------------------------------------------*/
void  fx_fwd.cross_quote(	number  	bid_quote,
							number 		ask_quote,
							fx_fwd		fx2,
							number 		fx2_bid_quote,
							number  	fx2_ask_quote,
							out number 				cross_bid,
							out number 				cross_ask,
							logical 				fx2_is_base,
							integer					cross_scale,
							integer 				cross_decimals,
							logical					cross_fix_spread,
							number option(nullable) cross_bid_spread,
							number option(nullable) cross_ask_spread,	
							logical 				cross_unit_quote,
							error_info option(nullable) error) 

{	
	try{
		instr_error ee 	= new instr_error();
		date mat 	= this.maturity();
		date mat2 	= fx2.maturity();
		CORE_INT.instr_fail_check(mat != mat2, "settlement date mismatch", this, ee);
		
		instr_error_type t;
   		string 	cross_base, cross_price, s;	
		i().__fx_cross_quote(bid_quote,ask_quote,fx2.i(), fx2_bid_quote,fx2_ask_quote,cross_bid,cross_ask,
										fx2_is_base,cross_scale,cross_decimals,cross_fix_spread,cross_bid_spread,
										cross_ask_spread, cross_unit_quote,cross_base, cross_price,t, s);
		logical e = CORE_INT.add_error_info(error,t,s, "fx_fwd.cross_quote");	
		if(e) {			
			cross_bid = cross_ask = null<number>;
		}
		return ;						
	}
	catch {
		cross_bid = cross_ask = null<number>;
		CORE_INT.catch_error_info(error,err.type(),err.message(), "fx_fwd.cross_quote");
		return ;
	}
}

/*-----------------------------------------------------------------------
  err funcs  
  ----------------------------------------------------------------------*/
//number fx_fwd.quote(..quote_style.quote_style quote_style,error_info option(nullable) error) 	{ fin_instr.err_type(1, error);}
number fx_fwd.quote(disc_func	disc_func,..quote_style	option(nullable) quote_style,									
					error_info option(nullable) error) 							{ return fin_instr.err_type(1.0, error);}


